- [HTTP request](https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.dataStores.servingConfigs/search#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.dataStores.servingConfigs/search#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.dataStores.servingConfigs/search#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.dataStores.servingConfigs/search#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.dataStores.servingConfigs/search#body.response_body)
- [Authorization scopes](https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.dataStores.servingConfigs/search#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.dataStores.servingConfigs/search#body.aspect_1)

Performs a search.

### HTTP request

Choose an endpoint:
global us   
`POST https://discoveryengine.googleapis.com/v1/{servingConfig=projects/*/locations/*/dataStores/*/servingConfigs/*}:search`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `servingConfig` | `string` Required. The resource name of the servingConfigs.search serving config, such as `projects/*/locations/global/collections/default_collection/engines/*/servingConfigs/default_serving_config`, or `projects/*/locations/global/collections/default_collection/dataStores/default_data_store/servingConfigs/default_serving_config`. This field is used to identify the serving configuration name, set of models used to make the search. |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "branch": string, "query": string, "pageCategories": [ string ], "imageQuery": { object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/ImageQuery`) }, "pageSize": integer, "pageToken": string, "offset": integer, "oneBoxPageSize": integer, "dataStoreSpecs": [ { object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/DataStoreSpec`) } ], "numResultsPerDataStore": integer, "filter": string, "canonicalFilter": string, "orderBy": string, "userInfo": { object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.dataStores.userEvents#UserInfo`) }, "languageCode": string, "facetSpecs": [ { object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/FacetSpec`) } ], "boostSpec": { object (`BoostSpec`) }, "params": { string: value, ... }, "queryExpansionSpec": { object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/QueryExpansionSpec`) }, "spellCorrectionSpec": { object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/SpellCorrectionSpec`) }, "userPseudoId": string, "contentSearchSpec": { object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/ContentSearchSpec`) }, "rankingExpression": string, "rankingExpressionBackend": enum (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/RankingExpressionBackend`), "safeSearch": boolean, "userLabels": { string: string, ... }, "naturalLanguageQueryUnderstandingSpec": { object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/NaturalLanguageQueryUnderstandingSpec`) }, "searchAsYouTypeSpec": { object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/SearchAsYouTypeSpec`) }, "displaySpec": { object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/DisplaySpec`) }, "crowdingSpecs": [ { object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/CrowdingSpec`) } ], "session": string, "sessionSpec": { object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/SessionSpec`) }, "relevanceThreshold": enum (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/RelevanceThreshold`), "relevanceFilterSpec": { object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/RelevanceFilterSpec`) }, "relevanceScoreSpec": { object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/RelevanceScoreSpec`) }, "searchAddonSpec": { object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/SearchAddonSpec`) }, "customRankingParams": { object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/CustomRankingParams`) }, "entity": string } ``` |

| Fields ||
|---|---|
| `branch` | `string` The branch resource name, such as `projects/*/locations/global/collections/default_collection/dataStores/default_data_store/branches/0`. Use `default_branch` as the branch ID or leave this field empty, to search documents under the default branch. |
| `query` | `string` Raw search query. |
| `pageCategories[]` | `string` Optional. The categories associated with a category page. Must be set for category navigation queries to achieve good search quality. The format should be the same as `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.dataStores.userEvents#PageInfo.FIELDS.page_category`. This field is the equivalent of the query for browse (navigation) queries. It's used by the browse model when the query is empty. If the field is empty, it will not be used by the browse model. If the field contains more than one element, only the first element will be used. To represent full path of a category, use '\>' character to separate different hierarchies. If '\>' is part of the category name, replace it with other character(s). For example, `Graphics Cards > RTX>4090 > Founders Edition` where "RTX \> 4090" represents one level, can be rewritten as `Graphics Cards > RTX_4090 > Founders Edition` |
| `imageQuery` | ``object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/ImageQuery`)`` Raw image query. |
| `pageSize` | `integer` Maximum number of `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.collections.dataStores.branches.documents#Document`s to return. The maximum allowed value depends on the data type. Values above the maximum value are coerced to the maximum value. - Websites with basic indexing: Default `10`, Maximum `25`. - Websites with advanced indexing: Default `25`, Maximum `50`. - Other: Default `50`, Maximum `100`. If this field is negative, an `INVALID_ARGUMENT` is returned. |
| `pageToken` | `string` A page token received from a previous `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.dataStores.servingConfigs/search#google.cloud.discoveryengine.v1.SearchService.Search` call. Provide this to retrieve the subsequent page. When paginating, all other parameters provided to `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.dataStores.servingConfigs/search#google.cloud.discoveryengine.v1.SearchService.Search` must match the call that provided the page token. Otherwise, an `INVALID_ARGUMENT` error is returned. |
| `offset` | `integer` A 0-indexed integer that specifies the current offset (that is, starting result location, amongst the `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.collections.dataStores.branches.documents#Document`s deemed by the API as relevant) in search results. This field is only considered if `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.dataStores.servingConfigs/search#body.request_body.FIELDS.page_token` is unset. If this field is negative, an `INVALID_ARGUMENT` is returned. A large offset may be capped to a reasonable threshold. |
| `oneBoxPageSize` | `integer` The maximum number of results to return for OneBox. This applies to each OneBox type individually. Default number is 10. |
| `dataStoreSpecs[]` | ``object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/DataStoreSpec`)`` Specifications that define the specific `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.collections.dataStores#DataStore`s to be searched, along with configurations for those data stores. This is only considered for `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.collections.engines#Engine`s with multiple data stores. For engines with a single data store, the specs directly under `SearchRequest` should be used. On an engine with multiple data stores, this field is optional. If it's empty, all of the engine's data stores are searched (blended search). Unless it specifies exactly one data store, some request fields, such as `orderBy` and `queryExpansionSpec`, aren't supported and return an `INVALID_ARGUMENT` error. |
| `numResultsPerDataStore` | `integer` Optional. The maximum number of results to retrieve from each data store. If not specified, it will use the `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/DataStoreSpec#FIELDS.num_results` if provided, otherwise there is no limit. |
| `filter` | `string` The filter syntax consists of an expression language for constructing a predicate from one or more fields of the documents being filtered. Filter expression is case-sensitive. If this field is unrecognizable, an `INVALID_ARGUMENT` is returned. Filtering in Vertex AI servingConfigs.search is done by mapping the LHS filter key to a key property defined in the Vertex AI servingConfigs.search backend -- this mapping is defined by the customer in their schema. For example a media customer might have a field 'name' in their schema. In this case the filter would look like this: filter --\> name:'ANY("king kong")' For more information about filtering including syntax and filter operators, see [Filter](https://cloud.google.com/generative-ai-app-builder/docs/filter-search-metadata) |
| `canonicalFilter` | `string` The default filter that is applied when a user performs a search without checking any filters on the search page. The filter applied to every search request when quality improvement such as query expansion is needed. In the case a query does not have a sufficient amount of results this filter will be used to determine whether or not to enable the query expansion flow. The original filter will still be used for the query expanded search. This field is strongly recommended to achieve high search quality. For more information about filter syntax, see `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.dataStores.servingConfigs/search#body.request_body.FIELDS.filter`. |
| `orderBy` | `string` The order in which documents are returned. Documents can be ordered by a field in an `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.collections.dataStores.branches.documents#Document` object. Leave it unset if ordered by relevance. `orderBy` expression is case-sensitive. For more information on ordering the website search results, see [Order web search results](https://cloud.google.com/generative-ai-app-builder/docs/order-web-search-results). For more information on ordering the healthcare search results, see [Order healthcare search results](https://cloud.google.com/generative-ai-app-builder/docs/order-hc-results). If this field is unrecognizable, an `INVALID_ARGUMENT` is returned. |
| `userInfo` | ``object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.dataStores.userEvents#UserInfo`)`` Information about the end user. Highly recommended for analytics and personalization. `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.dataStores.userEvents#UserInfo.FIELDS.user_agent` is used to deduce `deviceType` for analytics. |
| `languageCode` | `string` The BCP-47 language code, such as "en-US" or "sr-Latn". For more information, see [Standard fields](https://cloud.google.com/apis/design/standard_fields). This field helps to better interpret the query. If a value isn't specified, the query language code is automatically detected, which may not be accurate. |
| `facetSpecs[]` | ``object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/FacetSpec`)`` Facet specifications for faceted search. If empty, no facets are returned. A maximum of 100 values are allowed. Otherwise, an `INVALID_ARGUMENT` error is returned. |
| `boostSpec` | ``object (`BoostSpec`)`` Boost specification to boost certain documents. For more information on boosting, see [Boosting](https://cloud.google.com/generative-ai-app-builder/docs/boost-search-results) |
| `params` | ``map (key: string, value: value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format))`` Additional search parameters. For public website search only, supported values are: - `user_country_code`: string. Default empty. If set to non-empty, results are restricted or boosted based on the location provided. For example, `user_country_code: "au"` For available codes see [Country Codes](https://developers.google.com/custom-search/docs/json_api_reference#countryCodes) - `searchType`: double. Default empty. Enables non-webpage searching depending on the value. The only valid non-default value is 1, which enables image searching. For example, `searchType: 1` |
| `queryExpansionSpec` | ``object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/QueryExpansionSpec`)`` The query expansion specification that specifies the conditions under which query expansion occurs. |
| `spellCorrectionSpec` | ``object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/SpellCorrectionSpec`)`` The spell correction specification that specifies the mode under which spell correction takes effect. |
| `userPseudoId` | `string` Optional. A unique identifier for tracking visitors. For example, this could be implemented with an HTTP cookie, which should be able to uniquely identify a visitor on a single device. This unique identifier should not change if the visitor logs in or out of the website. This field should NOT have a fixed value such as `unknown_visitor`. This should be the same identifier as `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.dataStores.userEvents#UserEvent.FIELDS.user_pseudo_id` and `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.dataStores/completeQuery#body.QUERY_PARAMETERS.user_pseudo_id` The field must be a UTF-8 encoded string with a length limit of 128 characters. Otherwise, an `INVALID_ARGUMENT` error is returned. |
| `contentSearchSpec` | ``object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/ContentSearchSpec`)`` A specification for configuring the behavior of content search. |
| `rankingExpression` | `string` Optional. The ranking expression controls the customized ranking on retrieval documents. This overrides `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.collections.dataStores.servingConfigs#ServingConfig.FIELDS.ranking_expression`. The syntax and supported features depend on the `rankingExpressionBackend` value. If `rankingExpressionBackend` is not provided, it defaults to `RANK_BY_EMBEDDING`. If `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.dataStores.servingConfigs/search#body.request_body.FIELDS.ranking_expression_backend` is not provided or set to `RANK_BY_EMBEDDING`, it should be a single function or multiple functions that are joined by "+". - rankingExpression = function, { " + ", function }; Supported functions: - double \* relevanceScore - double \* dotProduct(embedding_field_path) Function variables: - `relevanceScore`: pre-defined keywords, used for measure relevance between query and document. - `embedding_field_path`: the document embedding field used with query embedding vector. - `dotProduct`: embedding function between `embedding_field_path` and query embedding vector. Example ranking expression: If document has an embedding field doc_embedding, the ranking expression could be `0.5 * relevanceScore + 0.3 * dotProduct(doc_embedding)`. If `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.dataStores.servingConfigs/search#body.request_body.FIELDS.ranking_expression_backend` is set to `RANK_BY_FORMULA`, the following expression types (and combinations of those chained using + or \* operators) are supported: - `double` - `signal` - `log(signal)` - `exp(signal)` - `rr(signal, double > 0)` -- reciprocal rank transformation with second argument being a denominator constant. - `isNan(signal)` -- returns 0 if signal is NaN, 1 otherwise. - `fillNan(signal1, signal2 | double)` -- if signal1 is NaN, returns signal2 \| double, else returns signal1. Here are a few examples of ranking formulas that use the supported ranking expression types: - `0.2 * semanticSimilarityScore + 0.8 * log(keywordSimilarityScore)` -- mostly rank by the logarithm of `keywordSimilarityScore` with slight `semantic_smilarity_score` adjustment. - `0.2 * exp(fillNan(semanticSimilarityScore, 0)) + 0.3 * isNan(keywordSimilarityScore)` -- rank by the exponent of `semanticSimilarityScore` filling the value with 0 if it's NaN, also add constant 0.3 adjustment to the final score if `semanticSimilarityScore` is NaN. - `0.2 * rr(semanticSimilarityScore, 16) + 0.8 * rr(keywordSimilarityScore, 16)` -- mostly rank by the reciprocal rank of `keywordSimilarityScore` with slight adjustment of reciprocal rank of `semantic_smilarity_score`. The following signals are supported: - `semanticSimilarityScore`: semantic similarity adjustment that is calculated using the embeddings generated by a proprietary Google model. This score determines how semantically similar a search query is to a document. - `keywordSimilarityScore`: keyword match adjustment uses the Best Match 25 (BM25) ranking function. This score is calculated using a probabilistic model to estimate the probability that a document is relevant to a given query. - `relevanceScore`: semantic relevance adjustment that uses a proprietary Google model to determine the meaning and intent behind a user's query in context with the content in the documents. - `pctrRank`: predicted conversion rate adjustment as a rank use predicted Click-through rate (pCTR) to gauge the relevance and attractiveness of a search result from a user's perspective. A higher pCTR suggests that the result is more likely to satisfy the user's query and intent, making it a valuable signal for ranking. - `freshnessRank`: freshness adjustment as a rank - `documentAge`: The time in hours elapsed since the document was last updated, a floating-point number (e.g., 0.25 means 15 minutes). - `topicalityRank`: topicality adjustment as a rank. uses proprietary Google model to determine the keyword-based overlap between the query and the document. - `baseRank`: the default rank of the result - `mediaActorMatch`: whether the media actor matches the query - `mediaDirectorMatch`: whether the media director matches the query - `mediaGenreMatch`: whether the media genre matches the query - `mediaLanguageMatch`: whether the media language matches the query - `mediaTitleMatch`: whether the media title matches the query - `mediaPrefixSimilarityRank`: prefix similarity rank for media results - `mediaSemanticSimilarityRank`: semantic similarity rank for media results |
| `rankingExpressionBackend` | ``enum (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/RankingExpressionBackend`)`` Optional. The backend to use for the ranking expression evaluation. |
| `safeSearch` | `boolean` Whether to turn on safe search. This is only supported for website search. |
| `userLabels` | `map (key: string, value: string)` The user labels applied to a resource must meet the following requirements: - Each resource can have multiple labels, up to a maximum of 64. - Each label must be a key-value pair. - Keys have a minimum length of 1 character and a maximum length of 63 characters and cannot be empty. Values can be empty and have a maximum length of 63 characters. - Keys and values can contain only lowercase letters, numeric characters, underscores, and dashes. All characters must use UTF-8 encoding, and international characters are allowed. - The key portion of a label must be unique. However, you can use the same key with multiple resources. - Keys must start with a lowercase letter or international character. See [Google Cloud Document](https://cloud.google.com/resource-manager/docs/creating-managing-labels#requirements) for more details. |
| `naturalLanguageQueryUnderstandingSpec` | ``object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/NaturalLanguageQueryUnderstandingSpec`)`` Optional. Config for natural language query understanding capabilities, such as extracting structured field filters from the query. Refer to [this documentation](https://cloud.google.com/generative-ai-app-builder/docs/natural-language-queries) for more information. If `naturalLanguageQueryUnderstandingSpec` is not specified, no additional natural language query understanding will be done. |
| `searchAsYouTypeSpec` | ``object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/SearchAsYouTypeSpec`)`` servingConfigs.search as you type configuration. Only supported for the `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/IndustryVertical#ENUM_VALUES.MEDIA` vertical. |
| `displaySpec` | ``object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/DisplaySpec`)`` Optional. Config for display feature, like match highlighting on search results. |
| `crowdingSpecs[]` | ``object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/CrowdingSpec`)`` Optional. Crowding specifications for improving result diversity. If multiple CrowdingSpecs are specified, crowding will be evaluated on each unique combination of the `field` values, and maxCount will be the maximum value of `maxCount` across all CrowdingSpecs. For example, if the first CrowdingSpec has `field` = "color" and `maxCount` = 3, and the second CrowdingSpec has `field` = "size" and `maxCount` = 2, then after 3 documents that share the same color AND size have been returned, subsequent ones should be removed or demoted. |
| `session` | `string` The session resource name. Optional. Session allows users to do multi-turn /search API calls or coordination between /search API calls and /answer API calls. Example #1 (multi-turn /search API calls): Call /search API with the session ID generated in the first call. Here, the previous search query gets considered in query standing. I.e., if the first query is "How did Alphabet do in 2022?" and the current query is "How about 2023?", the current query will be interpreted as "How did Alphabet do in 2023?". Example #2 (coordination between /search API calls and /answer API calls): Call /answer API with the session ID generated in the first call. Here, the answer generation happens in the context of the search results from the first search call. |
| `sessionSpec` | ``object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/SessionSpec`)`` Session specification. Can be used only when `session` is set. |
| `relevanceThreshold` | ``enum (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/RelevanceThreshold`)`` The global relevance threshold of the search results. Defaults to Google defined threshold, leveraging a balance of precision and recall to deliver both highly accurate results and comprehensive coverage of relevant information. If more granular relevance filtering is required, use the `relevanceFilterSpec` instead. This feature is not supported for healthcare search. |
| `relevanceFilterSpec` | ``object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/RelevanceFilterSpec`)`` Optional. The granular relevance filtering specification. If not specified, the global `relevanceThreshold` will be used for all sub-searches. If specified, this overrides the global `relevanceThreshold` to use thresholds on a per sub-search basis. This feature is currently supported only for custom and site search. |
| `relevanceScoreSpec` | ``object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/RelevanceScoreSpec`)`` Optional. The specification for returning the relevance score. |
| `searchAddonSpec` | ``object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/SearchAddonSpec`)`` Optional. SearchAddonSpec is used to disable add-ons for search as per new repricing model. This field is only supported for search requests. |
| `customRankingParams` | ``object (`https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/CustomRankingParams`)`` Optional. Optional configuration for the Custom Ranking feature. |
| `entity` | `string` Optional. The entity for customers that may run multiple different entities, domains, sites or regions, for example, "Google US", "Google Ads", "Waymo", "google.com", "youtube.com", etc. If this is set, it should be exactly matched with `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/projects.locations.dataStores.userEvents#UserEvent.FIELDS.entity` to get search results boosted by entity. |

### Response body

If successful, the response body contains an instance of `https://docs.cloud.google.com/gemini/enterprise/docs/reference/rest/v1/SearchResponse`.

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/cloud-platform`
- `https://www.googleapis.com/auth/discoveryengine.assist.readwrite`
- `https://www.googleapis.com/auth/discoveryengine.readwrite`
- `https://www.googleapis.com/auth/discoveryengine.serving.readwrite`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

### IAM Permissions

Requires the following [IAM](https://cloud.google.com/iam/docs) permission on the `servingConfig` resource:

- `discoveryengine.servingConfigs.search`

For more information, see the [IAM documentation](https://cloud.google.com/iam/docs).